#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif

#ifdef __BORLANDC__
#define ITK_LEAN_AND_MEAN
#endif

#include<itkImageFileWriter.h>
#include "itkImageFileReader.h"
#include <itkNormalizedCorrelationImageToImageMetric.h>
#include "itkImageRegionConstIterator.h"
#include "itkImageRegionIterator.h"
#include "itkImage.h"
#include <math.h>

int main( int argc, char ** argv )
{
  // Verify the number of parameters in the command line
  if( argc < 3 )
    {
    std::cerr << "Usage: " << std::endl;
    std::cerr << argv[0] << " InputVectorField  Scalar(float) OutputName" << std::endl;
    return EXIT_FAILURE;
    }




//Instantiation of a reader for vector field and a writer for image

  
  
  

  
  //Input file 
  
  typedef itk::Vector<float,3>  VectorPixelType;
typedef itk::Image<VectorPixelType,3> ImageType;
  typedef  float  PixelType;
typedef itk::Image<PixelType,3> NImageType;


typedef ImageType::Pointer ImagePointer;


typedef itk::ImageFileReader<ImageType> ImageReaderType;


typedef itk::ImageRegionIterator<ImageType> IteratorType;

 
ImageReaderType::Pointer reader1=ImageReaderType::New();
reader1->SetFileName(argv[1]);
reader1->UpdateLargestPossibleRegion();
reader1->Update();


  
  
///////////////////


ImageType::Pointer output = ImageType::New();
output->SetRegions(reader1->GetOutput()->GetLargestPossibleRegion());
output->SetSpacing(reader1->GetOutput()->GetSpacing());
output->SetOrigin(reader1->GetOutput()->GetOrigin());
output->SetDirection(reader1->GetOutput()->GetDirection());
output->Allocate();



typedef itk::ImageRegionIterator<ImageType> VectorIteratorType;	
VectorIteratorType out(output,reader1->GetOutput()->GetLargestPossibleRegion());

VectorPixelType Vect;
itk::Index<3> Index1;


std::cout << "Usage: " << atof(argv[2]) << std::endl;

	float a;	
for ( out.GoToBegin(); !out.IsAtEnd(); ++out )
{ 
  Index1=out.GetIndex();
  a=0;
   a=atof(argv[2]);
  out.Set(a*(reader1->GetOutput()->GetPixel(Index1)));
 }

typedef itk::ImageFileWriter< ImageType >  WriterType;
WriterType::Pointer writer = WriterType::New();


writer->SetInput( output );
writer->SetFileName( argv[3] );
writer->Update();

  return EXIT_SUCCESS;
  
}
